#![no_std]
#![no_main]

#[macro_use]
extern crate user_lib;
extern crate alloc;

use user_lib::{sys_getid, sys_fork, sys_open, sys_read, sys_write, sys_pipe, sys_close};
use alloc::string::String;

#[no_mangle]
pub fn main() -> usize {
    //fork
    // let res = sys_fork();
    // if res == 0 {
    //     println!("我是子进程");
    // } else {
    //     println!("我是父进程");
    // }
    //getid
    // println!("Hello world from user mode program! id = {}",id);
    //read file
    // let fd = sys_open("test_file");
    // if fd < 0 {
    //     panic!("无此文件")
    // }
    // let mut buffer = [0;64];
    // let len = sys_read(fd as usize, buffer.as_mut());
    // println!("共 {} 个字符: {:?}", len, String::from_utf8_lossy(&buffer[0..len as usize]));
    let mut fd = [0;2];
    let res =  sys_pipe(&mut fd);
    if res < 0 {
        panic!("创建管道失败")
    }
    let write_fd = fd[0];
    let read_fd = fd[1];
    if sys_fork() != 0 {
        // 父进程
        sys_write(read_fd, "hello_world".as_bytes());
    } else {
        // 子进程
        let mut buffer = [0u8; 64];
        let res = sys_read(read_fd, &mut buffer);
        if res < 0 {
            panic!("读取错误")
        }
        println!("{}", core::str::from_utf8(&buffer).unwrap());
    }
    0
}
